<compatibility-matrix version="1.0" type="framework">
    <hal format="hidl" optional="false">
        <name>android.hardware.audio</name>
        <version>2.0</version>
        <interface>
            <name>IDevicesFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.audio.effect</name>
        <version>2.0</version>
        <interface>
            <name>IEffectsFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.automotive.evs</name>
        <version>1.0</version>
        <interface>
            <name>IEvsEnumerator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.automotive.vehicle</name>
        <version>2.0</version>
        <interface>
            <name>IVehicle</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.biometrics.fingerprint</name>
        <version>2.1</version>
        <interface>
            <name>IBiometricsFingerprint</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.bluetooth</name>
        <version>1.0</version>
        <interface>
            <name>IBluetoothHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.boot</name>
        <version>1.0</version>
        <interface>
            <name>IBootControl</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.broadcastradio</name>
        <version>1.0</version>
        <interface>
            <name>IBroadcastRadioFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.camera.provider</name>
        <version>2.4</version>
        <interface>
            <name>ICameraProvider</name>
            <instance>legacy/0</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.configstore</name>
        <version>1.0-1</version>
        <interface>
            <name>ISurfaceFlingerConfigs</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.contexthub</name>
        <version>1.0</version>
        <interface>
            <name>IContexthub</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.drm</name>
        <version>1.0</version>
        <interface>
            <name>ICryptoFactory</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IDrmFactory</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.dumpstate</name>
        <version>1.0</version>
        <interface>
            <name>IDumpstateDevice</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.gatekeeper</name>
        <version>1.0</version>
        <interface>
            <name>IGatekeeper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.gnss</name>
        <version>1.0</version>
        <interface>
            <name>IGnss</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.graphics.allocator</name>
        <version>2.0</version>
        <interface>
            <name>IAllocator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.graphics.composer</name>
        <version>2.1</version>
        <interface>
            <name>IComposer</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.graphics.mapper</name>
        <version>2.0</version>
        <interface>
            <name>IMapper</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.health</name>
        <version>1.0</version>
        <interface>
            <name>IHealth</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.ir</name>
        <version>1.0</version>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.keymaster</name>
        <version>3.0</version>
        <interface>
            <name>IKeymasterDevice</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.light</name>
        <version>2.0</version>
        <interface>
            <name>ILight</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>android.hardware.media.omx</name>
        <version>1.0</version>
        <interface>
            <name>IOmx</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IOmxStore</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.memtrack</name>
        <version>1.0</version>
        <interface>
            <name>IMemtrack</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.nfc</name>
        <version>1.0</version>
        <interface>
            <name>INfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.power</name>
        <version>1.0</version>
        <interface>
            <name>IPower</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio</name>
        <version>1.0</version>
        <interface>
            <name>IRadio</name>
            <instance>slot1</instance>
        </interface>
        <interface>
            <name>ISap</name>
            <instance>slot1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.radio.deprecated</name>
        <version>1.0</version>
        <interface>
            <name>IOemHook</name>
            <instance>slot1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.renderscript</name>
        <version>1.0</version>
        <interface>
            <name>IDevice</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.sensors</name>
        <version>1.0</version>
        <interface>
            <name>ISensors</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.soundtrigger</name>
        <version>2.0</version>
        <interface>
            <name>ISoundTriggerHw</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.tetheroffload.config</name>
        <version>1.0</version>
        <interface>
            <name>IOffloadConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.tetheroffload.control</name>
        <version>1.0</version>
        <interface>
            <name>IOffloadControl</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.thermal</name>
        <version>1.0</version>
        <interface>
            <name>IThermal</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.tv.cec</name>
        <version>1.0</version>
        <interface>
            <name>IHdmiCec</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.tv.input</name>
        <version>1.0</version>
        <interface>
            <name>ITvInput</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.usb</name>
        <version>1.0</version>
        <interface>
            <name>IUsb</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.vibrator</name>
        <version>1.0</version>
        <interface>
            <name>IVibrator</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.vr</name>
        <version>1.0</version>
        <interface>
            <name>IVr</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.wifi</name>
        <version>1.0</version>
        <interface>
            <name>IWifi</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>android.hardware.wifi.supplicant</name>
        <version>1.0</version>
        <interface>
            <name>ISupplicant</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.ant</name>
        <version>1.0</version>
        <interface>
            <name>IAntHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.bluetooth_audio</name>
        <version>1.0</version>
        <interface>
            <name>IBluetoothAudio</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.dpm.api</name>
        <version>1.0</version>
        <interface>
            <name>IdpmQmi</name>
            <instance>dpmQmiService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.imscmservice</name>
        <version>1.0</version>
        <interface>
            <name>IImsCmService</name>
            <instance>qti.ims.connectionmanagerservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.uceservice</name>
        <version>1.0</version>
        <interface>
            <name>IUceService</name>
            <instance>com.qualcomm.qti.uceservice</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>com.qualcomm.qti.wifidisplayhal</name>
        <version>1.0</version>
        <interface>
            <name>IDSManager</name>
            <instance>wifidisplaydshal</instance>
        </interface>
        <interface>
            <name>IHDCPSession</name>
            <instance>wifidisplayhdcphal</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>com.quicinc.cne.api</name>
        <version>1.0</version>
        <interface>
            <name>IApiService</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>com.quicinc.cne.server</name>
        <version>1.0</version>
        <interface>
            <name>IServer</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>com.quicinc.cne.server</name>
        <version>2.0</version>
        <interface>
            <name>IServer</name>
            <instance>cnd</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.color</name>
        <version>1.0</version>
        <interface>
            <name>IDisplayColor</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.display.config</name>
        <version>1.0</version>
        <interface>
            <name>IDisplayConfig</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.nxp.hardware.nfc</name>
        <version>1.0</version>
        <interface>
            <name>INqNfc</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.esepowermanager</name>
        <version>1.0</version>
        <interface>
            <name>IEsePowerManager</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="false">
        <name>vendor.qti.gnss</name>
        <version>1.0</version>
        <interface>
            <name>ILocHidlGnss</name>
            <instance>gnss_vendor</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.alarm</name>
        <version>1.0</version>
        <interface>
            <name>IAlarm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.data.latency</name>
        <version>1.0</version>
        <interface>
            <name>ILinkLatency</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.fm</name>
        <version>1.0</version>
        <interface>
            <name>IFmHci</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.blobmanager</name>
        <version>1.0</version>
        <interface>
            <name>IBlobManager</name>
            <instance>BlobManagerService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.gesturemanager</name>
        <version>1.0</version>
        <interface>
            <name>IGestureManager</name>
            <instance>GestureManagerService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.improvetouch.touchcompanion</name>
        <version>1.0</version>
        <interface>
            <name>ITouchCompanion</name>
            <instance>TouchCompanionService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.perf</name>
        <version>1.0</version>
        <interface>
            <name>IPerf</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qdutils_disp</name>
        <version>1.0</version>
        <interface>
            <name>IQdutilsDisp</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.qteeconnector</name>
        <version>1.0</version>
        <interface>
            <name>IAppConnector</name>
            <instance>default</instance>
        </interface>
        <interface>
            <name>IGPAppConnector</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.am</name>
        <version>1.0</version>
        <interface>
            <name>IQcRilAudio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.atcmdfwd</name>
        <version>1.0</version>
        <interface>
            <name>IAtCmdFwd</name>
            <instance>AtCmdFwdService</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.config</name>
        <version>1.0</version>
        <interface>
            <name>IConfig</name>
            <instance>radioconfig0</instance>
            <instance>radioconfig1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.ims</name>
        <version>1.0</version>
        <interface>
            <name>IImsRadio</name>
            <instance>imsradio0</instance>
            <instance>imsradio1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.lpa</name>
        <version>1.0</version>
        <interface>
            <name>IUimLpa</name>
            <instance>UimLpa0</instance>
            <instance>UimLpa1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qcrilhook</name>
        <version>1.0</version>
        <interface>
            <name>IQtiOemHook</name>
            <instance>oemhook0</instance>
            <instance>oemhook1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.qtiradio</name>
        <version>1.0</version>
        <interface>
            <name>IQtiRadio</name>
            <instance>slot1</instance>
            <instance>slot2</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim</name>
        <version>1.0</version>
        <interface>
            <name>IUim</name>
            <instance>Uim0</instance>
            <instance>Uim1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_client</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceClient</name>
            <instance>uimRemoteClient0</instance>
            <instance>uimRemoteClient1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.radio.uim_remote_server</name>
        <version>1.0</version>
        <interface>
            <name>IUimRemoteServiceServer</name>
            <instance>uimRemoteServer0</instance>
            <instance>uimRemoteServer1</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.hardware.tui_comm</name>
        <version>1.0</version>
        <interface>
            <name>ITuiComm</name>
            <instance>default</instance>
        </interface>
    </hal>
    <hal format="hidl" optional="true">
        <name>vendor.qti.imsrtpservice</name>
        <version>1.0</version>
        <interface>
            <name>IRTPService</name>
            <instance>imsrtpservice</instance>
        </interface>
    </hal>
    <kernel version="4.9.0"/>
    <kernel version="4.4.0"/>
    <kernel version="3.18.0"/>
    <sepolicy>
        <kernel-sepolicy-version>30</kernel-sepolicy-version>
        <sepolicy-version>26.0</sepolicy-version>
    </sepolicy>
    <avb>
        <vbmeta-version>1.0</vbmeta-version>
    </avb>
</compatibility-matrix>
